float nc = 0;   // consigne de vitesse de la fourche en deg/s
float kp = 50;           // Coefficient proportionnel
float ki = 0;           // Coefficient intégrateur
float kd = 0;           // Coefficient dérivateur
float vref = 11.42; // tension de ref
const int pot = 5;  // potentiometre connecte a A5
const int mot = 9;   // moteur controle vitesse avec pwm
const int sens = 8;  // moteur controle sens
const int nmu = 1;   // tension de vitesse moteur
int potval = 0;
int pwm = 0;     // commande pwm moteur
float pwmf = 0;  // commande pwm float
int sensval = 0;
int nmuval = 0;
float vm = 0;        // tension moteur volt
float n = 0;    // la vitesse de la fourche en deg/s
float erp = 1;  // erreur de vitesse precedente
float erd = 0;  // derivee erreur
float ers = 0;  // Somme des erreurs pour l'intégrateur
float t = 0;           // temps
//division par : 1 (0x01),8 (02),64 (03),256 (04),1024 (05)
//byte division_frequence=0x01;

void setup() {
  // initialize serial communication at 9600 bits per second:
  //Serial.begin(115200);
  Serial.begin(9600);
  pinMode(pot, INPUT);
  pinMode(mot, OUTPUT);
  pinMode(sens, OUTPUT);
  pinMode(nmu, INPUT);

  //TCCR0B c'est le registre, on opère un masquage sur lui même
  //TCCR0B = TCCR0B & 0b11111000 | division_frequence;
  //ce qui permet de modifier la fréquence de la PWM
}

void loop() {
  //calcul vitesse de la fourche
  nmuval = analogRead(nmu);
  n = (float)nmuval * 87.9765 ;
  n = n / 12320 ;

  //calcul des ecarts
  erd = nc - n - erp;
  erd = erd / 0.01;
  ers = ers + (nc - n) * 0.01;
  
  // PID : calcul de la commande
  pwmf = kp*(nc-n) + kd*erd + ki*ers;
    
  //commande du moteur
  pwm = (int)pwmf;
  if(pwm < 0) pwm=0;
  else if(pwm > 255) pwm = 255;
  analogWrite(mot, pwm);
  vm = (float)pwm * vref / 255;
  
  //test moteur en tension J et Cr
  //pwm = 111; // 5V ici
  //analogWrite(mot, pwm);
  //vm = (float)pwm * vref / 255;
  
  //du potentiometre au moteur
  //potval = analogRead(pot);
  //pwm = map(potval, 0, 1023, 0, 255);
  //analogWrite(mot, pwm);
  //vm = (float)pwm * vref / 255;
  //sensval = 0;
  //analogWrite(sens, sensval);

  //bp1val = digitalRead(bp1);
  // print the results to the serial monitor:
  //Serial.print(nmuval);
  //Serial.print("\t");
  //Serial.println(n,4);
  //Serial.print("pwm = " );
  //Serial.print(pwm);
  //Serial.print("\t vm = ");
  //Serial.println(vm);
  Serial.print(t,3); //temps toutes les 10ms
  Serial.print("\t ");
  Serial.print(n,3); //vitesse de la fourche en °/s
  Serial.print("\t ");
  Serial.print(vm,3); //Tension moteur en V
  Serial.print("\t ");
  Serial.print(pwm); //Commande moteur
  Serial.print("\t ");
  Serial.println(pwmf,3); //Commande moteur corrigée
  
  erp = nc - n;
  t = t + 0.01;
  delay(10);   // delay en ms in between reads for stability
}
